<template>
  <div class="page-body">

    <vxe-form :data="formOptions.data" ref="xForm" :title-width="formOptions.titleWidth"
      :title-align="formOptions.titleAlign" :rules="formOptions.rules" :items="formOptions.items" titleColon>
      <template #myregion="{}">
        <a-input-search placeholder="input search text" enter-button />
      </template>
    </vxe-form>


    <div class="footerbar">
      <a-button type="primary" @click="ok">确定</a-button>
      <a-button @click="cancel">取消</a-button>
    </div>

  </div>
</template>

<script>
import BASE_URL from '@/services/base/api.js';

export default {
  i18n: require('./i18n'),

  props: {
    pageMode: {
      type: String,
      default: "edit"
    },
    dataId: {
    }

  },

  data() {

    // 页面数据变量
    var pageData = {

      actions: {
        create: `${BASE_URL.BASE_URL}/BasePermission/v1/role/create`,
        update: `${BASE_URL.BASE_URL}/BasePermission/v1/role/update`,
        get: `${BASE_URL.BASE_URL}/BasePermission/v1/role/detail`
      },

      formOptions: {

        data: {
        },

        titleWidth: 100,
        titleAlign: 'right',

        rules: {
          name: [
            { required: true, message: '角色名不能为空' }
          ]
        },

        items: [
          { field: 'name',  title: '角色名', span: 24, itemRender: { name: '$input', props: { placeholder: '请输入角色名' } } },
          { field: 'desc', title: '描述', span: 24, itemRender: { name: '$textarea', props: { placeholder: '请输入描述' } } },
          
        ]
      }

    };

    for (let ruleName in pageData.formOptions.rules) {
      let rule = pageData.formOptions.rules[ruleName];
      if (rule && rule[0]) {
        if (rule[0].required === true) {
          pageData.formOptions.data[ruleName] = "";
        }
      }
    }

    pageData.formOptions = Object.assign({}, this.$mk.config.defaults.formOptions, pageData.formOptions);

    return pageData;
  },
  created() {
    if (this.dataId) {
      this.$mk.post({
        url: this.actions.get,
        loading: "加载中...",
        data: {
          id: this.dataId
        }
      }).then(a => {
        this.formOptions.data = a.data.role;
      }).catch((a) => {
        this.$mk.error(a.data.msg);
      });
    }

  },
  // 函数
  methods: {


    loadData() {
    },

    ok() {

      let save = () => {
        let action = this.pageMode == "add" ? this.actions.create : this.actions.update;
        let postdata = this.pageMode == "add" ? Object.assign({ id: this.dataId }, this.formOptions.data) : Object.assign({}, this.formOptions.data);

        this.$mk.formatFormData({ data: postdata, rules: this.formOptions.items });
        this.$mk.post({
          url: action,
          loading: "保存中...",
          data: postdata
        }).then(() => {
          this.$mk.success("保存成功");
          this.$emit("callback", { success: true });
        }).catch((a) => {
          this.$mk.error(a.data.msg);
        });
      };

      this.$mk.validateForm({ form: this.$refs.xForm }).then(() => {
        save();
      }).catch(count => {
        this.$mk.error(`存在${count}项错误，请检查`);
      });


    },

    cancel() {
      this.$emit("callback", {});
    }
  },
  // 监听属性
  watch: {

  }
};

</script>
<style>

</style>
